window.select = (function() {

	var isIe8 = !window.getComputedStyle;

	function core(el, opts) {
		var self = this
		self.el = {}

		if (el) {
			self.el.select = $(el)
			self.el.select.addClass('pretty')
			this.init(opts||{})
		}
	}

	core.prototype.init = function(opts) {
		var self = this

		self.isMobile = false
		if ('ontouchstart' in document.documentElement) {
			self.isMobile = true
		}

		self.itemCount = 0

		var active = self.el.select.find(':selected')

		self.value = active.val()
		self.valueText = active.text()
		self.onchange = opts.onchange||null

		self.el.container = $('<div class="select_container"></div>')
		
		// add select elements classes to container

		var classlist = self.el.select.get(0).classList;

		if ( isIe8 ) {
			self.el.select.get(0).className;
			self.el.select.eq(0).addClass("pretty");
		} else {
			if (classlist.length) {
				$.each(classlist, function(i, cls) {
					self.el.container.addClass(cls)
				})
			}
		}

		self.el.container.on('click touchend',function(ev){
			ev.stopPropagation()
			closeAll(self.el.options)
		})

		self.id = self.el.select.attr('id')||(new Date()).getTime()

		self.el.selected = $('<div class="selected"></div>')
		self.el.label = $('<label></label>').data('value', self.value).attr('for', self.id).append( $('<span></span>').text(self.valueText) )
		self.el.label.on('click touchend',function(ev){
			ev.stopPropagation()
		})

		self.el.selected.append( self.el.label )
		self.el.selected.appendTo(self.el.container)

		if (self.isMobile) {
			self.el.label.on('click touchend', function() {
				self.el.select.trigger('click')
			})
		}

		self.el.select.on('change', function(ev) {
			var $this = $(this)
			self.el.label.data('value', $this.val()).find('span').text($this.find(':selected').text())
		})

		if (!self.isMobile) {
			self.el.options = $('<ul class="options reset"></ul>').appendTo(self.el.container).hide()
			self.el.select.find('option').each(function() {
				var option = $('<li><button><span></span></button></li>')
				var $this = $(this)
				option.find('span').text( $this.text() )
				option.data('value', $this.val())

				if ($this.is(':selected')) {
					option.addClass('selected')
				}
				if ($this.is(':disabled')) {
					option.addClass('disabled')
				}

				option.appendTo(self.el.options)
			})

			self.el.label.on('click', function(ev) {
				if (self.el.options.is(':visible')) {
					self.el.options.hide()
				} else {
					self.el.options.show()
				}
			})

			self.el.options.find('button').on('click', function(ev) {
				ev.preventDefault()

				self.el.select.val( $(this).parent().data('value') ).trigger('change')

				self.el.options.hide()
			})
		}

		self.el.container.insertAfter(self.el.select)
		self.el.select.appendTo(self.el.container)

		if (self.isMobile) {
			self.el.select.css({
				opacity: 0,
				position: 'absolute',
				top: 0, left: 0,
//				width: self.el.label.width(),
//				height: self.el.label.height()
				display: 'block',
        height: '40px'
			})
		} else {
			self.el.select.hide()
		}
	}


	var closeAll = function(ignore){
		var selects = $('.select_container .options').filter(':visible')
		if (ignore) selects = selects.not(ignore)
		if (selects.length) {
			selects.hide()
		}
	}

	$(window).on('click', function(ev) {
		closeAll()
	})

	return function(el, opts) {
		if (el && $(el).hasClass('pretty')) return
		var c = new core(el, opts)
		$(el).data('api', c)
		return c
	}
})();
